'                                  /   \
'                          )      ((   ))     (
'( )                      /|\      ))_((     /|\
'|-|                     / | \    (/\|/\)   / | \                      ( )
'| |--------------------/--|-voV---\`|'/--Vov-|--\---------------------|-|
'|-|                         '^`   (o o)  '^`                          | |
'| |   X-GUI 4 setup source codes  `\Y/'      Kenneth Garin (coder)    |-|
'|-|                                          Joe Bardell (bugs/extra) | |
'| |   Compile EXE using SVGAPV.QLB           Stephen Balkum (svgapv)  |-|
'|-|                                          Daniel Sill (svgapv)     | |
'| |   Syntax- PDS 7.1 (or VBDOS)             HTTP://WWW.XGUI.NET      |-|
'|_|___________________________________________________________________| |
'( )              l   /\ /         ( (       \ /\   l                `\|-|
'                 l /   V           \ \       V   \ l                  ( )
'                 l/                _) )_          \I
'                                   `\ /'
'
DECLARE SUB disp ()
'$INCLUDE: 'SVGABC.BI'

start:
CLEAR
disp
PRINT "Please choose a screen resolution to use..."
PRINT
PRINT "   (1)  640x400"
PRINT "   (2)  640x480"
PRINT "   (3)  800x600"
PRINT "   (4)  1024x768"
PRINT "   (5)  1280x1024"
PRINT "   (6)  Quit"
PRINT
PRINT "   Select one of the following by pressing its number... :"
DO
 k$ = INKEY$
 SELECT CASE k$
  CASE "1"
   PRINT : PRINT "You selected 640x400.";
   EXIT DO
  CASE "2"
   PRINT : PRINT "You selected 640x480.";
   EXIT DO
  CASE "3"
   PRINT : PRINT "You selected 800x600.";
   EXIT DO
  CASE "4"
   PRINT : PRINT "You selected 1024x768.";
   EXIT DO
  CASE "5"
   PRINT : PRINT "You selected 1280x1024.";
   EXIT DO
  CASE "6"
   PRINT
   PRINT "You selected 6, so now setup will quit w/o making any changes."
   PRINT "Press any key to exit..."
   DO UNTIL INKEY$ <> "": LOOP
   SYSTEM
 END SELECT
LOOP
COLOR 4
PRINT " Press any key to test this screen mode..."
DO UNTIL INKEY$ <> "": LOOP
r% = WHICHVGA
x% = WHICHXMS(mem%, handles%)
IF mem% < 1 OR handles% < 1 THEN
 disp
 PRINT "No XMS (extended) memory available, please check that a memory driver"
 PRINT "like HIMEM.SYS is running. X-GUI needs at least 2MB of XMS memory to"
 PRINT "run."
 PRINT "Press any key to exit setup..."
 DO UNTIL INKEY$ <> "": LOOP
 SYSTEM
END IF
SELECT CASE k$
 CASE "1"
  t% = RES640L%: m$ = "640x400"
 CASE "2"
  t% = RES640%: m$ = "640x480"
 CASE "3"
  t% = RES800%: m$ = "800x600"
 CASE "4"
  t% = RES1024%: m$ = "1024x768"
 CASE "5"
  t% = RES1280%: m$ = "1280x1024"
END SELECT
IF t% <> 1 THEN
 disp
 PRINT "Your computer setup can't use this screen resolution."
 PRINT "Please press any key to go back and choose another selection..."
 DO UNTIL INKEY$ <> "": LOOP
 GOTO start
END IF
fontsystem
FOR x = 0 TO 1280 STEP 20
 c = c + 1
 drwfillbox 1, c, x, 0, x + 19, 1024
NEXT
drwstring 1, 0, 15, "Screen Test, Please Wait...", 0, 0
drwfillbox 1, 7, 100, 100, 500, 300
drwbox 1, 0, 100, 100, 500, 300
drwstring 1, 15, 7, "Text in box", 120, 120
h% = XMSSCREENGET%
a% = PAGEACTIVE%(1)
e% = XMSSCREENPUT%(h%)
e% = XMSFREE%(h%)
a% = PAGEACTIVE%(0)
DO
a% = PAGEDISPLAY%(0, 0, 1)
t# = TIMER
IF t# <> r# THEN r# = TIMER: l = l + 1
IF l = 60 THEN EXIT DO
DO UNTIL t# <> TIMER: LOOP
a% = PAGEDISPLAY%(0, 0, 0)
LOOP
disp
PRINT "Did the test display correctly? If there was ANY bad flickering"
PRINT "or any disturbed graphics then please go back and change your"
PRINT "selection for what screen resolution you want to use."
PRINT
PRINT " (1)  Go back"
PRINT " (2)  Use this resolution"
DO
 k$ = INKEY$
 IF k$ = "1" THEN GOTO start
 IF k$ = "2" THEN EXIT DO
LOOP
PRINT
IF DIR$("SETTINGS.INI") <> "" THEN
 PRINT "There is already a existing SETTINGS.INI file, should it be overwrote?"
 PRINT " * Note that this will reset all of X-GUI's settings to defaults"
 PRINT
 PRINT " (1)  Yes"
 PRINT " (2)  No"
 DO
  k$ = INKEY$
  IF k$ = "1" THEN EXIT DO
  IF k$ = "2" THEN
   PRINT
   PRINT "You selected NO, so now setup will quit w/o making any changes."
   PRINT "Press any key to exit..."
   DO UNTIL INKEY$ <> "": LOOP
   SYSTEM
  END IF
 LOOP
END IF
OPEN "SETTINGS.INI" FOR OUTPUT AS #1
PRINT #1, "MODE " + m$
PRINT #1, "MOUSE POINTER MOUSE.POI"
PRINT #1, "MOUSE TIMER TIMER.POI"
PRINT #1, "BACKGROUND COLOR 7"
PRINT #1, "TITLE COLOR 31"
PRINT #1, "ACTIVE COLOR 125"
PRINT #1, "NONACT COLOR 7"
PRINT #1, "SYSTEM FONT COURIER.FON"
PRINT #1, "WALLPAPER LOGO.PCX"
CLOSE #1
PRINT
PRINT "Changes have now been made, you may start X-GUI by using"
PRINT "START at the DOS prompt."
PRINT "Press any key to exit..."
PRINT
PRINT
COLOR 7, 0
DO UNTIL INKEY$ <> "": LOOP

SUB disp
tt% = RESTEXT%
COLOR 1, 7: CLS
PRINT "X-GUI 4 SETUP"
PRINT "------------------"
PRINT
END SUB

