'                                  /   \
'                          )      ((   ))     (
'( )                      /|\      ))_((     /|\
'|-|                     / | \    (/\|/\)   / | \                      ( )
'| | -------------------/--|-voV---\`|'/--Vov-|--\---------------------|-|
'|-|                         '^`   (o o)  '^`                          | |
'| |   XLANG TO X SCRIPT FILE      `\Y/'      Kenneth Garin (coder)    |-|
'|-|                                          Joe Bardell (bugs/extra) | |
'| |   For KG Software internal usage                                  |-|
'|-|                                                                   | |
'| |   Syntax- PDS 7.1 (or VBDOS)             HTTP://WWW.XGUI.NET      |-|
'|_|___________________________________________________________________| |
'( )              l   /\ /         ( (       \ /\   l                `\|-|
'                 l /   V           \ \       V   \ l                  ( )
'                 l/                _) )_          \I
'                                   `\ /'
'
DECLARE FUNCTION findlabel! (label$)
DIM SHARED infile$, outfile$

PRINT
COLOR 10
PRINT "X-GUI version 4 XLANG to XSF compiler for DOS, KG Software 2001."
COLOR 7

c$ = LTRIM$(RTRIM$(COMMAND$))

IF c$ = "/?" OR c$ = "-H" THEN
 PRINT " Syntax: XLA2XSF filename.xla filename.xsf"
 SYSTEM
END IF

IF c$ = "" THEN
 LINE INPUT "XLANG (XLA) FILENAME: ", infile$: infile$ = LTRIM$(RTRIM$(infile$))
 IF infile$ = "" THEN SYSTEM
 LINE INPUT "XSF FILENAME: ", outfile$: outfile$ = LTRIM$(RTRIM$(outfile$))
 IF outfile$ = "" THEN SYSTEM
 ELSE
 infile$ = LEFT$(c$, INSTR(c$, " ") - 1)
 outfile$ = MID$(c$, INSTR(c$, " ") + 1)
END IF

PRINT "INPUT FILE: " + infile$
PRINT "OUTPUT FILE: " + outfile$

IF DIR$(infile$) = "" THEN PRINT "File " + infile$ + " not found.": SYSTEM

OPEN infile$ FOR INPUT AS #1
OPEN "pars.tmp" FOR OUTPUT AS #2
PRINT CHR$(13) + CHR$(254) + " Checking file..."
DO UNTIL EOF(1)
 LINE INPUT #1, a$
 a$ = LTRIM$(RTRIM$(a$))
 IF LEFT$(UCASE$(a$), 6) = "SETUP " THEN a$ = LTRIM$(MID$(a$, 7)): se = 1
 IF a$ <> "" AND LEFT$(a$, 1) <> ";" THEN
  IF LEFT$(UCASE$(a$), 4) <> "VAR " THEN
   PRINT #2, a$
   ELSE
   IF INSTR(a$, ",") = 0 THEN
    a$ = LTRIM$(MID$(a$, 4))
    IF RIGHT$(a$, 1) = "$" THEN a$ = a$ + "," + CHR$(34) + CHR$(34)
    IF RIGHT$(a$, 1) = "%" THEN a$ = a$ + ",0"
    IF INSTR(a$, " ") > 0 THEN
     b$ = LTRIM$(MID$(a$, INSTR(a$, " ") + 1))
     a$ = RTRIM$(LEFT$(a$, INSTR(a$, " ") - 1)) + "," + b$
    END IF
    PRINT #2, "VAR " + a$
    ELSE
    a$ = MID$(a$, 4) + ","
    DO UNTIL INSTR(a$, ",") = 0
     b$ = LEFT$(a$, INSTR(a$, ",") - 1)
     a$ = MID$(a$, INSTR(a$, ",") + 1)
     c$ = LTRIM$(RTRIM$(b$)): d$ = ""
     IF INSTR(c$, " ") > 0 THEN
      d$ = "," + LTRIM$(MID$(c$, INSTR(c$, " ") + 1))
      c$ = RTRIM$(LEFT$(c$, INSTR(c$, " ") - 1))
     END IF
     IF d$ = "" THEN
      IF RIGHT$(c$, 1) = "$" THEN d$ = "," + CHR$(34) + CHR$(34)
      IF RIGHT$(c$, 1) = "%" THEN d$ = ",0"
     END IF
     PRINT #2, "VAR " + c$ + d$
    LOOP
   END IF
  END IF
 END IF
LOOP
CLOSE #1, #2
IF se = 0 THEN PRINT : PRINT "Missing SETUP in file": SYSTEM

OPEN "pars.tmp" FOR INPUT AS #1
DO UNTIL EOF(1)
 LINE INPUT #1, dummy$
 codelines = codelines + 1
LOOP
CLOSE #1

CSR = CSRLIN
OPEN "pars.tmp" FOR INPUT AS #1
OPEN outfile$ FOR OUTPUT AS #2
PRINT CHR$(254) + " Compiling file...";
DO UNTIL EOF(1)
 LINE INPUT #1, a$
 curline = curline + 1
 LOCATE CSR, 20
 PRINT STR$(FIX((curline / codelines) * 100)) + "%   ";
 b$ = UCASE$(a$)
 c = c + 1
 g = 0
 IF LEFT$(b$, 4) = "JMP " THEN a$ = CHR$(2) + LTRIM$(STR$(findlabel(MID$(a$, 5)))): g = 1
 IF RIGHT$(b$, 1) = ":" THEN a$ = "": g = 1
 IF LEFT$(b$, 3) = "JE " THEN a$ = CHR$(3) + LTRIM$(STR$(findlabel(MID$(a$, 4)))): g = 1
 IF LEFT$(b$, 4) = "JNE " THEN a$ = CHR$(4) + LTRIM$(STR$(findlabel(MID$(a$, 5)))): g = 1
 IF LEFT$(b$, 3) = "JA " THEN a$ = CHR$(5) + LTRIM$(STR$(findlabel(MID$(a$, 4)))): g = 1
 IF LEFT$(b$, 4) = "JAE " THEN a$ = CHR$(6) + LTRIM$(STR$(findlabel(MID$(a$, 5)))): g = 1
 IF LEFT$(b$, 3) = "JB " THEN a$ = CHR$(7) + LTRIM$(STR$(findlabel(MID$(a$, 4)))): g = 1
 IF LEFT$(b$, 4) = "JBE " THEN a$ = CHR$(11) + LTRIM$(STR$(findlabel(MID$(a$, 5)))): g = 1
 IF LEFT$(b$, 5) = "CALL " THEN a$ = CHR$(1) + LTRIM$(STR$(findlabel(MID$(a$, 6)))): g = 1
 IF b$ = "RET" THEN a$ = "R": g = 1
 IF LEFT$(b$, 4) = "VAR " THEN a$ = CHR$(127) + MID$(a$, 5): g = 1
 IF b$ = "END" THEN a$ = "E": g = 1
 IF LEFT$(b$, 6) = "PRINT " THEN a$ = CHR$(129) + MID$(a$, 7): g = 1
 IF LEFT$(b$, 7) = "LPRINT " THEN a$ = "L" + MID$(a$, 8): g = 1
 IF LEFT$(b$, 6) = "COLOR " THEN a$ = CHR$(12) + MID$(a$, 7): g = 1
 IF LEFT$(b$, 5) = "FONT " THEN a$ = CHR$(130) + MID$(a$, 6): g = 1
 IF LEFT$(b$, 4) = "MOV " THEN a$ = CHR$(128) + MID$(a$, 5): g = 1
 IF LEFT$(b$, 4) = "ADD " THEN a$ = CHR$(140) + MID$(a$, 5): g = 1
 IF LEFT$(b$, 4) = "SUB " THEN a$ = CHR$(141) + MID$(a$, 5): g = 1
 IF LEFT$(b$, 4) = "MUL " THEN a$ = CHR$(142) + MID$(a$, 5): g = 1
 IF LEFT$(b$, 4) = "DIV " THEN a$ = CHR$(143) + MID$(a$, 5): g = 1
 IF LEFT$(b$, 4) = "CMP " THEN a$ = CHR$(144) + MID$(a$, 5): g = 1
 IF LEFT$(b$, 4) = "FIX " THEN a$ = CHR$(17) + MID$(a$, 5): g = 1
 IF LEFT$(b$, 4) = "INC " THEN a$ = CHR$(131) + MID$(a$, 5): g = 1
 IF LEFT$(b$, 4) = "DEC " THEN a$ = CHR$(132) + MID$(a$, 5): g = 1
 IF LEFT$(b$, 6) = "INKEY " THEN a$ = CHR$(150) + MID$(a$, 7): g = 1
 IF LEFT$(b$, 6) = "PANIC " THEN a$ = "!" + MID$(a$, 7): g = 1
 IF LEFT$(b$, 6) = "TITLE " THEN a$ = "#" + MID$(a$, 7): g = 1
 IF LEFT$(b$, 7) = "RESIZE " THEN a$ = "@" + MID$(a$, 8): g = 1
 IF LEFT$(b$, 9) = "FONTINFO " THEN a$ = CHR$(253) + MID$(a$, 10): g = 1
 IF LEFT$(b$, 7) = "LOCATE " THEN a$ = CHR$(151) + MID$(a$, 8): g = 1
 IF LEFT$(b$, 7) = "GETLOC " THEN a$ = CHR$(152) + MID$(a$, 8): g = 1
 IF LEFT$(b$, 4) = "FRE " THEN a$ = CHR$(20) + MID$(a$, 5): g = 1
 IF LEFT$(b$, 12) = "MOUSESTATUS " THEN a$ = CHR$(153) + MID$(a$, 13): g = 1
 IF LEFT$(b$, 13) = "_MOUSESTATUS " THEN a$ = CHR$(154) + MID$(a$, 14): g = 1
 IF LEFT$(b$, 10) = "SYSTEMFONT" THEN a$ = "\" + MID$(a$, 11): g = 1
 IF LEFT$(b$, 9) = "MOUSEHIDE" THEN a$ = CHR$(155): g = 1
 IF LEFT$(b$, 9) = "MOUSESHOW" THEN a$ = CHR$(156): g = 1
 IF LEFT$(b$, 5) = "SIZE " THEN a$ = "WS" + MID$(a$, 5): g = 1
 IF LEFT$(b$, 12) = "SCREEN_SIZE " THEN a$ = "{" + MID$(a$, 13): g = 1
 IF LEFT$(b$, 5) = "LINE " THEN a$ = CHR$(157) + MID$(a$, 6): g = 1
 IF LEFT$(b$, 5) = "SKIP " THEN a$ = "Z" + MID$(a$, 6): g = 1
 IF LEFT$(b$, 5) = "POKE " THEN a$ = CHR$(43) + MID$(a$, 6): g = 1
 IF LEFT$(b$, 5) = "PEEK " THEN a$ = CHR$(45) + MID$(a$, 6): g = 1
 IF LEFT$(b$, 4) = "BOX " THEN a$ = CHR$(158) + MID$(a$, 5): g = 1
 IF LEFT$(b$, 8) = "FILLBOX " THEN a$ = CHR$(159) + MID$(a$, 9): g = 1
 IF LEFT$(b$, 5) = "PSET " THEN a$ = CHR$(160) + MID$(a$, 6): g = 1
 IF LEFT$(b$, 8) = "GETPSET " THEN a$ = "GP " + MID$(a$, 9): g = 1
 IF LEFT$(b$, 7) = "CIRCLE " THEN a$ = CHR$(161) + MID$(a$, 8): g = 1
 IF LEFT$(b$, 11) = "FILLCIRCLE " THEN a$ = ")" + MID$(a$, 12): g = 1
 IF LEFT$(b$, 8) = "PCXLOAD " THEN a$ = CHR$(162) + MID$(a$, 9): g = 1
 IF LEFT$(b$, 8) = "PCXSAVE " THEN a$ = CHR$(163) + MID$(a$, 9): g = 1
 IF LEFT$(b$, 8) = "PCXINFO " THEN a$ = CHR$(164) + MID$(a$, 9): g = 1
 IF LEFT$(b$, 9) = "FILLAREA " THEN a$ = "FA" + MID$(a$, 9): g = 1
 IF LEFT$(b$, 7) = "XMSGET " THEN a$ = "XG" + MID$(a$, 7): g = 1
 IF LEFT$(b$, 7) = "XMSPUT " THEN a$ = "XP" + MID$(a$, 7): g = 1
 IF LEFT$(b$, 8) = "XMSFREE " THEN a$ = "XF" + MID$(a$, 8): g = 1
 IF LEFT$(b$, 5) = "KILL " THEN a$ = CHR$(165) + MID$(a$, 6): g = 1
 IF LEFT$(b$, 6) = "SHELL " THEN a$ = ">" + MID$(a$, 7): g = 1
 IF LEFT$(b$, 6) = "MKDIR " THEN a$ = CHR$(172) + MID$(a$, 7): g = 1
 IF LEFT$(b$, 6) = "RMDIR " THEN a$ = CHR$(171) + MID$(a$, 7): g = 1
 IF LEFT$(b$, 4) = "RUN " THEN a$ = CHR$(170) + MID$(a$, 5): g = 1
 IF LEFT$(b$, 7) = "GETCMD " THEN a$ = "_GC" + MID$(a$, 7): g = 1
 IF LEFT$(b$, 6) = "CHDIR " THEN a$ = CHR$(180) + MID$(a$, 7): g = 1
 IF LEFT$(b$, 7) = "CURDIR " THEN a$ = CHR$(181) + MID$(a$, 8): g = 1
 IF LEFT$(b$, 10) = "CHECKFILE " THEN a$ = CHR$(182) + MID$(a$, 11): g = 1
 IF LEFT$(b$, 5) = "TIME " THEN a$ = CHR$(133) + MID$(a$, 6): g = 1
 IF LEFT$(b$, 5) = "DATE " THEN a$ = CHR$(134) + MID$(a$, 6): g = 1
 IF LEFT$(b$, 8) = "SETTIME " THEN a$ = CHR$(135) + MID$(a$, 9): g = 1
 IF LEFT$(b$, 8) = "SETDATE " THEN a$ = CHR$(136) + MID$(a$, 9): g = 1
 IF b$ = "SYS" THEN a$ = b$: g = 1
 IF b$ = "RES" THEN a$ = b$: g = 1
 IF LEFT$(b$, 3) = "IN " THEN a$ = CHR$(138) + MID$(a$, 4): g = 1
 IF LEFT$(b$, 4) = "OUT " THEN a$ = CHR$(137) + MID$(a$, 5): g = 1
 IF LEFT$(b$, 4) = "ASC " THEN a$ = CHR$(190) + MID$(a$, 5): g = 1
 IF LEFT$(b$, 4) = "CHR " THEN a$ = CHR$(191) + MID$(a$, 5): g = 1
 IF LEFT$(b$, 6) = "LTRIM " THEN a$ = CHR$(192) + MID$(a$, 7): g = 1
 IF LEFT$(b$, 6) = "RTRIM " THEN a$ = CHR$(193) + MID$(a$, 7): g = 1
 IF LEFT$(b$, 7) = "LRTRIM " THEN a$ = CHR$(194) + MID$(a$, 8): g = 1
 IF LEFT$(b$, 4) = "ERR " THEN a$ = CHR$(195) + MID$(a$, 5): g = 1
 IF LEFT$(b$, 5) = "LEFT " THEN a$ = CHR$(196) + MID$(a$, 6): g = 1
 IF LEFT$(b$, 6) = "RIGHT " THEN a$ = CHR$(197) + MID$(a$, 7): g = 1
 IF LEFT$(b$, 4) = "MID " THEN a$ = CHR$(198) + MID$(a$, 5): g = 1
 IF LEFT$(b$, 6) = "UCASE " THEN a$ = CHR$(199) + MID$(a$, 7): g = 1
 IF LEFT$(b$, 6) = "LCASE " THEN a$ = CHR$(200) + MID$(a$, 7): g = 1
 IF LEFT$(b$, 4) = "STR " THEN a$ = CHR$(201) + MID$(a$, 5): g = 1
 IF LEFT$(b$, 6) = "INSTR " THEN a$ = CHR$(202) + MID$(a$, 7): g = 1
 IF LEFT$(b$, 4) = "LEN " THEN a$ = CHR$(203) + MID$(a$, 5): g = 1
 IF LEFT$(b$, 6) = "SOUND " THEN a$ = CHR$(204) + MID$(a$, 6): g = 1
 IF LEFT$(b$, 4) = "ABS " THEN a$ = "ABS" + MID$(a$, 4): g = 1
 IF LEFT$(b$, 4) = "COS " THEN a$ = "COS" + MID$(a$, 4): g = 1
 IF LEFT$(b$, 4) = "SIN " THEN a$ = "SIN" + MID$(a$, 4): g = 1
 IF LEFT$(b$, 4) = "TAN " THEN a$ = "TAN" + MID$(a$, 4): g = 1
 IF LEFT$(b$, 4) = "ATN " THEN a$ = "ATN" + MID$(a$, 4): g = 1
 IF LEFT$(b$, 4) = "HEX " THEN a$ = "HEX" + MID$(a$, 4): g = 1
 IF LEFT$(b$, 4) = "OCT " THEN a$ = "OCT" + MID$(a$, 4): g = 1
 IF LEFT$(b$, 4) = "MOD " THEN a$ = "MOD" + MID$(a$, 4): g = 1
 IF LEFT$(b$, 7) = "RANDOM " THEN a$ = "RAN" + MID$(a$, 7): g = 1
 IF LEFT$(b$, 6) = "TIMER " THEN a$ = "TMR" + MID$(a$, 6): g = 1
 IF LEFT$(b$, 5) = "OPEN " THEN a$ = "O" + MID$(a$, 5): g = 1
 IF LEFT$(b$, 6) = "CLOSE " THEN a$ = "CL" + MID$(a$, 6): g = 1
 IF LEFT$(b$, 9) = "FREEFILE " THEN a$ = "FH" + MID$(a$, 9): g = 1
 IF LEFT$(b$, 10) = "FILEINPUT " THEN a$ = "FI" + MID$(a$, 10): g = 1
 IF LEFT$(b$, 10) = "FILEWRITE " THEN a$ = "FW" + MID$(a$, 10): g = 1
 IF LEFT$(b$, 10) = "WALLPAPER " THEN a$ = "b" + MID$(a$, 11): g = 1
 IF LEFT$(b$, 9) = "ACTCOLOR " THEN a$ = "a" + MID$(a$, 10): g = 1
 IF LEFT$(b$, 12) = "NONACTCOLOR " THEN a$ = "n" + MID$(a$, 13): g = 1
 IF LEFT$(b$, 11) = "TITLECOLOR " THEN a$ = "t" + MID$(a$, 12): g = 1
 IF LEFT$(b$, 8) = "BGCOLOR " THEN a$ = "c" + MID$(a$, 9): g = 1
 IF LEFT$(b$, 8) = "FILEGET " THEN a$ = "FG" + MID$(a$, 8): g = 1
 IF LEFT$(b$, 8) = "FILEPUT " THEN a$ = "FP" + MID$(a$, 8): g = 1
 IF LEFT$(b$, 4) = "LOF " THEN a$ = "LOF" + MID$(a$, 4): g = 1
 IF LEFT$(b$, 4) = "EOF " THEN a$ = "EOF" + MID$(a$, 4): g = 1
 IF LEFT$(b$, 4) = "DIR " THEN a$ = "DIR" + MID$(a$, 4): g = 1
 IF LEFT$(b$, 8) = "POINTER " THEN a$ = "POI" + MID$(a$, 8): g = 1
 IF LEFT$(b$, 4) = "PID " THEN a$ = "PID" + MID$(a$, 4): g = 1
 IF LEFT$(b$, 3) = "OP " THEN a$ = "OP" + MID$(a$, 3): g = 1
 IF LEFT$(b$, 8) = "HOMEDIR " THEN a$ = "HD" + MID$(a$, 8): g = 1
 IF LEFT$(b$, 6) = "PCHAR " THEN a$ = CHR$(14) + MID$(a$, 7): g = 1
 IF LEFT$(b$, 7) = "REPAIR " THEN a$ = "`" + MID$(a$, 8): g = 1
 IF b$ = "SWITCHOFF" THEN a$ = "S-": g = 1
 IF b$ = "SWITCHON" THEN a$ = "S+": g = 1
 IF g = 0 AND c > 1 THEN COLOR 12: PRINT CHR$(13) + "SYNTAX ERROR: " + a$: COLOR 7: g = 2: EXIT DO
 PRINT #2, a$
LOOP
CLOSE #1, #2
IF g = 2 THEN
 IF DIR$(outfile$) <> "" THEN KILL outfile$
END IF
IF DIR$("PARS.TMP") <> "" THEN KILL "PARS.TMP"
PRINT CHR$(13) + "DONE." + CHR$(13)

FUNCTION findlabel (label$)
' find where label is located in file

IF RIGHT$(label$, 1) <> ":" THEN label$ = label$ + ":"
OPEN "pars.tmp" FOR INPUT AS #3
DO UNTIL EOF(3)
 LINE INPUT #3, a$
 l = l + 1
 IF UCASE$(a$) = UCASE$(LTRIM$(label$)) THEN find = l: EXIT DO
LOOP
CLOSE #3
IF find = 0 THEN COLOR 12: PRINT "LABEL NOT FOUND- " + label$: COLOR 7: CLOSE : SYSTEM
findlabel = find
END FUNCTION

